"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var with_lifecycle_1 = require("@hocs/with-lifecycle");
var react_redux_1 = require("react-redux");
var recompose_1 = require("recompose");
var mapValues = require("lodash.mapvalues");
function createRecord(state, stateName) {
    var _a;
    return _a = {}, _a[stateName] = state, _a;
}
function createTransforms() {
    return {
        withLifecycle: function (spec) {
            return with_lifecycle_1.default(spec);
        },
        withStateHandlers: function (createState, stateName, stateUpdaters) {
            var createStateForRecompose = (createState instanceof Function)
                ? function (props) { return createRecord(createState(props), stateName); }
                : createRecord(createState, stateName);
            return recompose_1.withStateHandlers(createStateForRecompose, mapValues(stateUpdaters, function (updater) { return function (state, props) {
                var handler = updater(state[stateName], props);
                return function () {
                    var payload = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        payload[_i] = arguments[_i];
                    }
                    return createRecord(handler.apply(void 0, payload), stateName);
                };
            }; }));
        },
        withHandlers: function (handlers) {
            return recompose_1.withHandlers(handlers);
        },
        withRedux: function (mapStateToProps, mapDispatchToProps) {
            return react_redux_1.connect(mapStateToProps, mapDispatchToProps);
        },
        withDefaultProps: function (defaultPropsArgument) {
            // recompose `defaultProps` is not strongly typed, so we have to cast it to `any` here
            return recompose_1.defaultProps(defaultPropsArgument);
        },
        withProps: function (createNewProps) {
            return recompose_1.withProps(createNewProps);
        },
        omitProps: function () {
            return function (component) { return component; };
        },
        branch: function (test, trueComponent) {
            return recompose_1.branch(test, recompose_1.renderComponent(trueComponent));
        },
        branchByProp: function (propName, test, trueComponent) {
            return recompose_1.branch(function (_a) {
                var _b = propName, prop = _a[_b];
                return test(prop);
            }, recompose_1.renderComponent(trueComponent));
        },
        pure: function () {
            return function (component) { return recompose_1.pure(component); };
        },
    };
}
exports.default = createTransforms;
